/*
Az ISP-probapanel 7 szegmenses kijelzojenek kezelesi programja.
A program binaris (0..15, a szamlalo valtozo kezdeti erteket BIN allandora kell
allitani, szamlalo = BIN), illetve decimalis (0..9, a szamlalo valtozo kezdeti
erteket DEC allandora kell allitani, szamlalo = DEC) eloreszamlalokent mukodik.

Az elejen egy 1 s-es kijelzoellenorzes van (minden szegmense vilagit).

A szamlalas 1 s-kent tortenik.
*/

#include <avr/io.h>
#include <util/delay.h>

#define DEC 10
#define BIN 16

const unsigned char szam[16] = {
                                 0x81 /*0*/, 0xD7 /*1*/, 0xA4 /*2*/, 0x94 /*3*/,
								 0xD2 /*4*/, 0x98 /*5*/, 0x88 /*6*/, 0xD5 /*7*/,
								 0x80 /*8*/, 0x90 /*9*/, 0xC0 /*A*/, 0x8A /*b*/,
								 0xA9 /*C*/, 0x86 /*d*/, 0xA8 /*E*/, 0xE8 /*F*/
								};

int main(void) {
  short i;
  unsigned char szamlalo = DEC;
  
  DDRC = 0xFF;
  PORTC = 0x00;
  
  _delay_ms(2000);
  PORTC = 0xFF;
  _delay_ms(1000);
  
  for (;;) {
    for (i = 0; i < szamlalo; i++) {
	  PORTC = szam[i];
	  _delay_ms(1000);
	}

	PORTC = 0xFF;
	_delay_ms(1000);
  }
  
  return(0);
}
